'use strict'

var _interopRequireDefault = require('@babel/runtime/helpers/interopRequireDefault')

exports.__esModule = true
exports.ssr = ssr

var _server = _interopRequireDefault(require('react-dom/server'))

var _GraphQL = require('../universal/GraphQL')

async function ssr(
  graphql,
  node,
  render = _server.default.renderToStaticMarkup
) {
  if (!(graphql instanceof _GraphQL.GraphQL))
    throw new Error('ssr() argument 1 must be a GraphQL instance.')
  if (arguments.length < 2)
    throw new Error('ssr() argument 2 must be a React node.')
  if (typeof render !== 'function')
    throw new Error('ssr() argument 3 must be a function.')
  graphql.ssr = true

  async function recurse() {
    const string = render(node)
    const operations = Object.values(graphql.operations)

    if (operations.length) {
      await Promise.all(operations)
      return recurse()
    } else {
      delete graphql.ssr
      return string
    }
  }

  return recurse()
}
